package testing;

import java.lang.reflect.Method;

import com.esotericsoftware.reflectasm.MethodAccess;
import com.goldencode.p2j.util.Utils;

public class MthdTest
{

   public static void main(String[] args)
   throws Exception
   {
      testMethodCall(8000000);
   }
   
   private static void testMethodCall(int n)
   throws Exception
   {
      MethodAccess access = MethodAccess.get(MthdTest.class);
      int idx = access.getIndex("testMe", String.class);
      Method m = MthdTest.class.getDeclaredMethod("testMe", String.class);
      
      long n1 = System.nanoTime();
      for (int i = 0; i < n; i++)
      {
         access.invoke(null, idx, "bla");
      }
      long n2 = System.nanoTime();
      System.out.println((n2 - n1) / 1000000d);

      Utils.invoke(m, null, "bla");
      n1 = System.nanoTime();
      for (int i = 0; i < n; i++)
      {
         Utils.invoke(m, null, "bla");
      }
      n2 = System.nanoTime();
      System.out.println((n2 - n1) / 1000000d);

      n1 = System.nanoTime();
      for (int i = 0; i < n; i++)
      {
         m.invoke(null, "bla");
      }
      n2 = System.nanoTime();
      System.out.println((n2 - n1) / 1000000d);

      n1 = System.nanoTime();
      for (int i = 0; i < n; i++)
      {
         testMe("bla");
      }
      n2 = System.nanoTime();
      System.out.println((n2 - n1) / 1000000d);
   }
   
   public static void testMe(String s1)
   {
      
   }

}

